import { Controller, Inject, Post } from '@midwayjs/decorator';
import { Context } from '@midwayjs/koa';
import { InitService } from '../../service/system/init.service';
@Controller('/init')
export class InitController {
  @Inject()
  ctx: Context;

  @Inject()
  service: InitService;

  @Post('/')
  async index() {
    const result = await this.service.adminUser();
    if (!result) return 'ok';
    // 未初始化,则执行初始化程序
    await this.service.initRole()
    await this.service.initMenus()
    await this.service.initRoleMenu(result)
  }
}
