import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'achieve' },
})
export class Achieve extends BaseModel {
  @prop({ required: false, index: true, zh: '所属人' })
  owner: string;
  @prop({ required: false, index: true, zh: '成果名称' })
  name: string;
  @prop({ required: false, index: false, zh: '行业分类', remark: '字典' })
  industry: string;
  @prop({ required: false, index: false, zh: '成果属性', remark: '字典' })
  attr: string;
  @prop({ required: false, index: false, zh: '出让方式', remark: '字典' })
  way: string;
  @prop({ required: false, index: false, zh: '成熟度', remark: '字典' })
  maturity: string;
  @prop({ required: false, index: false, zh: '技术分类', remark: '字典' })
  tech: string;
  @prop({ required: false, index: false, zh: '成果地区', remark: '字典' })
  area: string;
  @prop({ required: false, index: false, zh: '发布时间' })
  time: string;
  @prop({ required: false, index: false, zh: '交易金额' })
  money: string;
  @prop({ required: false, index: false, zh: '公开信息', remark: '字段:对应显示方式' })
  public_info: object;
  @prop({ required: false, index: false, zh: '附件' })
  files: Array<any>;
  @prop({ required: false, index: false, zh: '成果描述' })
  desc: string;
  @prop({ required: false, index: false, zh: '状态', remark: '字典', default: '0' })
  status: string;
}
