import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'demand' },
})
export class Demand extends BaseModel {
  @prop({ required: false, index: true, zh: '所属人', remark: '个人/企业' })
  owner: string;
  @prop({ required: false, index: true, zh: '需求标题' })
  title: string;
  @prop({ required: false, index: false, zh: '需求领域', remark: '字典' })
  industry_sector: string;
  @prop({ required: false, index: false, zh: '需求紧急度', remark: '字典' })
  urgency: string;
  @prop({ required: false, index: false, zh: '合作方式', remark: '字典' })
  way: string;
  @prop({ required: false, index: false, zh: '需求开始时间', remark: '' })
  start_time: string;
  @prop({ required: false, index: false, zh: '需求结束时间' })
  end_time: string;
  @prop({ required: false, index: false, zh: '地区', remark: '字典' })
  area: string;
  @prop({ required: false, index: false, zh: '需求详情' })
  desc: string;
  @prop({ required: false, index: true, zh: '需求状态', default: '0' })
  status: string;
}
