import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'service' },
})
export class Service extends BaseModel {
  @prop({ required: false, index: true, zh: '服务提供人' })
  owner: string;
  @prop({ required: false, index: true, zh: '服务标题' })
  title: string;
  @prop({ required: false, index: true, zh: '服务类型', remark: '字典' })
  type: string;
  @prop({ required: false, index: false, zh: '标签' })
  tags: Array<any>;
  @prop({ required: false, index: false, zh: '服务方式', remark: '字典' })
  way: string;
  @prop({ required: false, index: false, zh: '服务地区', remark: '字典' })
  area: string;
  @prop({ required: false, index: false, zh: '价格' })
  money: string;
  @prop({ required: false, index: false, zh: '描述' })
  desc: string;
  @prop({ required: false, index: true, zh: '状态', default: '0', remark: '字典' })
  status: string;
}
