import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'auction' },
})
export class Auction extends BaseModel {
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({ required: false, index: true, zh: '服务机构' })
  org: string;
  @prop({ required: false, index: false, zh: '项目编号' })
  code: string;
  @prop({ required: false, index: false, zh: '开始时间' })
  start_time: string;
  @prop({ required: false, index: false, zh: '结束时间' })
  end_time: string;
  @prop({ required: false, index: false, zh: '公告说明' })
  desc: string;
  @prop({ required: false, index: false, zh: '挂牌交易(自选成果形成)' })
  listing: Array<any>;
  @prop({ required: false, index: false, zh: '公告备注' })
  remark: string;
  @prop({ required: false, index: true, zh: '状态', remark: '字典', default: '0' })
  status: string;
}
