import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'listing' },
})
export class Listing extends BaseModel {
  @prop({ required: false, index: true, zh: '申请人' })
  owner: string;
  @prop({ required: false, index: true, zh: '公告标题' })
  title: string;
  @prop({ required: false, index: false, zh: '服务机构' })
  org: string;
  @prop({ required: false, index: false, zh: '项目编号' })
  code: string;
  @prop({ required: false, index: false, zh: '公告开始时间' })
  start_time: string;
  @prop({ required: false, index: false, zh: '公告结束时间' })
  end_time: string;
  @prop({ required: false, index: false, zh: '关联成果', ref: 'Achieve', remark: '挂牌只有1个' })
  achieve: string;
  @prop({ required: false, index: false, zh: '挂牌价' })
  money: string;
  @prop({ required: false, index: false, zh: '公告备注' })
  remark: string;
  @prop({ required: false, index: true, zh: '状态', default: '0' })
  status: string;
}
