import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'negotiate' },
})
export class Negotiate extends BaseModel {
  @prop({ required: false, index: true, zh: '所属人' })
  owner: string;
  @prop({ required: false, index: true, zh: '专利号' })
  no: string;
  @prop({ required: false, index: false, zh: '联系邮箱' })
  email: string;
  @prop({ required: false, index: false, zh: '受让方是否是成果完成人或者其利害关系人', remark: '字典', default: '0' })
  has_connect: string;
  @prop({ required: false, index: false, zh: '出让方式', remark: '字典' })
  way: string;
  @prop({ required: false, index: false, zh: '公示备注' })
  public_remark: string;
  @prop({ required: false, index: true, zh: '交易成果', remark: '只有一个', ref: 'Achieve' })
  achieve: string;
  @prop({ required: false, index: false, zh: '拟定价格' })
  money: string;
  @prop({ required: false, index: false, zh: '公告开始时间' })
  start_time: string;
  @prop({ required: false, index: false, zh: '公告结束时间' })
  end_time: string;
  @prop({ required: false, index: true, zh: '状态', default: '0' })
  status: string;
}
