import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { isString } from 'lodash';
@modelOptions({
  schemaOptions: { collection: 'research' },
})
export class Research extends BaseModel {
  @prop({ required: false, index: true, zh: '账户' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: object;
  @prop({ required: false, index: false, zh: '科研单位名称' })
  unit_name: string;
  @prop({ required: false, index: false, zh: '科研领域' })
  fields: Array<any>;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '单位人数' })
  worker_num: string;
  @prop({ required: false, index: false, zh: '联系人' })
  contact: string;
  @prop({ required: false, index: false, zh: '联系人电话' })
  tel: string;
  @prop({ required: false, index: false, zh: '单位相册' })
  files: Array<any>;
  @prop({ required: false, index: false, zh: '联系邮箱' })
  email: string;
  @prop({ required: false, index: true, zh: '状态', default: '0' })
  status: string;
}
