import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { isString } from 'lodash';
@modelOptions({
  schemaOptions: { collection: 'selfUser' },
})
export class SelfUser extends BaseModel {
  @prop({ required: false, index: true, zh: '账户' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: object;
  @prop({ required: false, index: false, zh: '用户名' })
  nick_name: string;
  @prop({ required: false, index: false, zh: '工作单位' })
  unit: string;
  @prop({ required: false, index: false, zh: '联系电话' })
  tel: string;
  @prop({ required: false, index: true, zh: '身份证号' })
  id_card: string;
  @prop({ required: false, index: false, zh: '联系邮箱' })
  email: string;
  @prop({ required: false, index: true, zh: '状态', default: '0' })
  status: string;
}
