import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { isString } from 'lodash';
@modelOptions({
  schemaOptions: { collection: 'unit' },
})
export class Unit extends BaseModel {
  @prop({ required: false, index: true, zh: '账户' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: object;
  @prop({ required: false, index: false, zh: '企业名称' })
  unit_name: string;
  @prop({ required: false, index: true, zh: '统一社会信用代码' })
  unit_code: string;
  @prop({ required: false, index: false, zh: '法人' })
  legal_person: string;
  @prop({ required: false, index: false, zh: '法人身份证号' })
  legal_card: string;
  @prop({ required: false, index: false, zh: '法人联系电话' })
  legal_tel: string;
  @prop({ required: false, index: false, zh: '联系邮箱' })
  email: string;
  @prop({ required: false, index: false, zh: '营业执照' })
  files: Array<any>;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: true, zh: '状态', default: '0' })
  status: string;
}
