import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_service {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '所属人' })
  'owner': string = undefined;
  @ApiProperty({ description: '服务标题' })
  'title': string = undefined;
  @ApiProperty({ description: '服务类型' })
  'type': string = undefined;
  @ApiProperty({ description: '标签' })
  'tags': Array<any> = undefined;
  @ApiProperty({ description: '服务方式' })
  'way': string = undefined;
  @ApiProperty({ description: '服务地区' })
  'area': string = undefined;
  @ApiProperty({ description: '价格' })
  'money': string = undefined;
  @ApiProperty({ description: '描述' })
  'desc': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_service extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['owner', 'title', 'type', 'type[]', 'way', 'way[]', 'area', 'area[]', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '所属人' })
  'owner': string = undefined;
  @ApiProperty({ description: '服务标题' })
  'title': string = undefined;
  @ApiProperty({ description: '服务类型' })
  'type': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_service extends FVO_service {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_service {
  @ApiProperty({ description: '所属人' })
  @Rule(RuleType['string']().empty(''))
  'owner': string = undefined;
  @ApiProperty({ description: '服务标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '服务类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '标签' })
  @Rule(RuleType['array']().empty(''))
  'tags': Array<any> = undefined;
  @ApiProperty({ description: '服务方式' })
  @Rule(RuleType['string']().empty(''))
  'way': string = undefined;
  @ApiProperty({ description: '服务地区' })
  @Rule(RuleType['string']().empty(''))
  'area': string = undefined;
  @ApiProperty({ description: '价格' })
  @Rule(RuleType['string']().empty(''))
  'money': string = undefined;
  @ApiProperty({ description: '描述' })
  @Rule(RuleType['string']().empty(''))
  'desc': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_service extends FVO_service {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_service extends CDTO_service {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_service extends FVO_service {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
