import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_auction {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '服务机构' })
  'org': string = undefined;
  @ApiProperty({ description: '项目编号' })
  'code': string = undefined;
  @ApiProperty({ description: '开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  'end_time': string = undefined;
  @ApiProperty({ description: '公告说明' })
  'desc': string = undefined;
  @ApiProperty({ description: '挂牌交易' })
  'listing': Array<any> = undefined;
  @ApiProperty({ description: '公告备注' })
  'remark': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_auction extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['title', 'org', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '服务机构' })
  'org': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_auction extends FVO_auction {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_auction {
  @ApiProperty({ description: '标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '服务机构' })
  @Rule(RuleType['string']().empty(''))
  'org': string = undefined;
  @ApiProperty({ description: '项目编号' })
  @Rule(RuleType['string']().empty(''))
  'code': string = undefined;
  @ApiProperty({ description: '开始时间' })
  @Rule(RuleType['string']().empty(''))
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  @Rule(RuleType['string']().empty(''))
  'end_time': string = undefined;
  @ApiProperty({ description: '公告说明' })
  @Rule(RuleType['string']().empty(''))
  'desc': string = undefined;
  @ApiProperty({ description: '挂牌交易' })
  @Rule(RuleType['array']().empty(''))
  'listing': Array<any> = undefined;
  @ApiProperty({ description: '公告备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_auction extends FVO_auction {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_auction extends CDTO_auction {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_auction extends FVO_auction {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
