import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_listing {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '申请人' })
  'owner': string = undefined;
  @ApiProperty({ description: '公告标题' })
  'title': string = undefined;
  @ApiProperty({ description: '服务机构' })
  'org': string = undefined;
  @ApiProperty({ description: '项目编号' })
  'code': string = undefined;
  @ApiProperty({ description: '公告开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '公告结束时间' })
  'end_time': string = undefined;
  @ApiProperty({ description: '关联成果' })
  'achieve': string = undefined;
  @ApiProperty({ description: '挂牌价' })
  'money': string = undefined;
  @ApiProperty({ description: '公告备注' })
  'remark': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_listing extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['owner', 'title', 'status', 'status[]'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '申请人' })
  'owner': string = undefined;
  @ApiProperty({ description: '公告标题' })
  'title': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_listing extends FVO_listing {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_listing {
  @ApiProperty({ description: '申请人' })
  @Rule(RuleType['string']().empty(''))
  'owner': string = undefined;
  @ApiProperty({ description: '公告标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '服务机构' })
  @Rule(RuleType['string']().empty(''))
  'org': string = undefined;
  @ApiProperty({ description: '项目编号' })
  @Rule(RuleType['string']().empty(''))
  'code': string = undefined;
  @ApiProperty({ description: '公告开始时间' })
  @Rule(RuleType['string']().empty(''))
  'start_time': string = undefined;
  @ApiProperty({ description: '公告结束时间' })
  @Rule(RuleType['string']().empty(''))
  'end_time': string = undefined;
  @ApiProperty({ description: '关联成果' })
  @Rule(RuleType['string']().empty(''))
  'achieve': string = undefined;
  @ApiProperty({ description: '挂牌价' })
  @Rule(RuleType['string']().empty(''))
  'money': string = undefined;
  @ApiProperty({ description: '公告备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_listing extends FVO_listing {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_listing extends CDTO_listing {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_listing extends FVO_listing {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
