import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_negotiate {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '所属人' })
  'owner': string = undefined;
  @ApiProperty({ description: '专利号' })
  'no': string = undefined;
  @ApiProperty({ description: '联系邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '受让方是否是成果完成人或者其利害关系人' })
  'has_connect': string = undefined;
  @ApiProperty({ description: '出让方式' })
  'way': string = undefined;
  @ApiProperty({ description: '公示备注' })
  'public_remark': string = undefined;
  @ApiProperty({ description: '关联成果' })
  'achieve': string = undefined;
  @ApiProperty({ description: '拟定价格' })
  'money': string = undefined;
  @ApiProperty({ description: '公告开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '公告结束时间' })
  'end_time': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_negotiate extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['owner', 'no', 'achieve', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '所属人' })
  'owner': string = undefined;
  @ApiProperty({ description: '专利号' })
  'no': string = undefined;
  @ApiProperty({ description: '关联成果' })
  'achieve': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_negotiate extends FVO_negotiate {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_negotiate {
  @ApiProperty({ description: '所属人' })
  @Rule(RuleType['string']().empty(''))
  'owner': string = undefined;
  @ApiProperty({ description: '专利号' })
  @Rule(RuleType['string']().empty(''))
  'no': string = undefined;
  @ApiProperty({ description: '联系邮箱' })
  @Rule(RuleType['string']().empty(''))
  'email': string = undefined;
  @ApiProperty({ description: '受让方是否是成果完成人或者其利害关系人' })
  @Rule(RuleType['string']().empty(''))
  'has_connect': string = undefined;
  @ApiProperty({ description: '出让方式' })
  @Rule(RuleType['string']().empty(''))
  'way': string = undefined;
  @ApiProperty({ description: '公示备注' })
  @Rule(RuleType['string']().empty(''))
  'public_remark': string = undefined;
  @ApiProperty({ description: '关联成果' })
  @Rule(RuleType['string']().empty(''))
  'achieve': string = undefined;
  @ApiProperty({ description: '拟定价格' })
  @Rule(RuleType['string']().empty(''))
  'money': string = undefined;
  @ApiProperty({ description: '公告开始时间' })
  @Rule(RuleType['string']().empty(''))
  'start_time': string = undefined;
  @ApiProperty({ description: '公告结束时间' })
  @Rule(RuleType['string']().empty(''))
  'end_time': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_negotiate extends FVO_negotiate {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_negotiate extends CDTO_negotiate {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_negotiate extends FVO_negotiate {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
