import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_linkItem {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '事项名称' })
  'title': string = undefined;
  @ApiProperty({ description: '图标' })
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '跳转至' })
  'to': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_linkItem extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_linkItem extends FVO_linkItem {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_linkItem {
  @ApiProperty({ description: '事项名称' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '图标' })
  @Rule(RuleType['array']().empty(''))
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '跳转至' })
  @Rule(RuleType['string']().empty(''))
  'to': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_linkItem extends FVO_linkItem {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_linkItem extends CDTO_linkItem {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_linkItem extends FVO_linkItem {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
