import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_policy {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '发布人' })
  'owner': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '发布时间' })
  'time': string = undefined;
  @ApiProperty({ description: '标题图片' })
  'files': Array<any> = undefined;
  @ApiProperty({ description: '来源' })
  'source': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_policy extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['owner'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '发布人' })
  'owner': string = undefined;
}

export class QVO_policy extends FVO_policy {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_policy {
  @ApiProperty({ description: '发布人' })
  @Rule(RuleType['string']().empty(''))
  'owner': string = undefined;
  @ApiProperty({ description: '标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '发布时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
  @ApiProperty({ description: '标题图片' })
  @Rule(RuleType['array']().empty(''))
  'files': Array<any> = undefined;
  @ApiProperty({ description: '来源' })
  @Rule(RuleType['string']().empty(''))
  'source': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_policy extends FVO_policy {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_policy extends CDTO_policy {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_policy extends FVO_policy {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
