import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_research {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '账户' })
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  'password': string = undefined;
  @ApiProperty({ description: '科研单位名称' })
  'unit_name': string = undefined;
  @ApiProperty({ description: '科研领域' })
  'fields': Array<any> = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '单位人数' })
  'worker_num': string = undefined;
  @ApiProperty({ description: '联系人' })
  'contact': string = undefined;
  @ApiProperty({ description: '联系人电话' })
  'tel': string = undefined;
  @ApiProperty({ description: '单位相册' })
  'files': Array<any> = undefined;
  @ApiProperty({ description: '联系邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_research extends SearchBase {
  constructor() {
    const like_prop = ['account'];
    const props = ['account', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '账户' })
  'account': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_research extends FVO_research {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_research {
  @ApiProperty({ description: '账户' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
  @ApiProperty({ description: '科研单位名称' })
  @Rule(RuleType['string']().empty(''))
  'unit_name': string = undefined;
  @ApiProperty({ description: '科研领域' })
  @Rule(RuleType['array']().empty(''))
  'fields': Array<any> = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '单位人数' })
  @Rule(RuleType['string']().empty(''))
  'worker_num': string = undefined;
  @ApiProperty({ description: '联系人' })
  @Rule(RuleType['string']().empty(''))
  'contact': string = undefined;
  @ApiProperty({ description: '联系人电话' })
  @Rule(RuleType['string']().empty(''))
  'tel': string = undefined;
  @ApiProperty({ description: '单位相册' })
  @Rule(RuleType['array']().empty(''))
  'files': Array<any> = undefined;
  @ApiProperty({ description: '联系邮箱' })
  @Rule(RuleType['string']().empty(''))
  'email': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_research extends FVO_research {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_research extends CDTO_research {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_research extends FVO_research {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
