import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_selfUser {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '账户' })
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  'password': string = undefined;
  @ApiProperty({ description: '用户名' })
  'nick_name': string = undefined;
  @ApiProperty({ description: '工作单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '联系电话' })
  'tel': string = undefined;
  @ApiProperty({ description: '身份证号' })
  'id_card': string = undefined;
  @ApiProperty({ description: '联系邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_selfUser extends SearchBase {
  constructor() {
    const like_prop = ['account'];
    const props = ['account', 'id_card', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '账户' })
  'account': string = undefined;
  @ApiProperty({ description: '身份证号' })
  'id_card': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_selfUser extends FVO_selfUser {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_selfUser {
  @ApiProperty({ description: '账户' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
  @ApiProperty({ description: '用户名' })
  @Rule(RuleType['string']().empty(''))
  'nick_name': string = undefined;
  @ApiProperty({ description: '工作单位' })
  @Rule(RuleType['string']().empty(''))
  'unit': string = undefined;
  @ApiProperty({ description: '联系电话' })
  @Rule(RuleType['string']().empty(''))
  'tel': string = undefined;
  @ApiProperty({ description: '身份证号' })
  @Rule(RuleType['string']().empty(''))
  'id_card': string = undefined;
  @ApiProperty({ description: '联系邮箱' })
  @Rule(RuleType['string']().empty(''))
  'email': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_selfUser extends FVO_selfUser {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_selfUser extends CDTO_selfUser {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_selfUser extends FVO_selfUser {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
