import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { Listing } from '../../../entity/core/trade/listing.entity';
import { Types } from 'mongoose';
const ObjectId = Types.ObjectId;
type modelType = ReturnModelType<typeof Listing>;
@Provide()
export class ListingService extends BaseService<modelType> {
  @InjectEntityModel(Listing)
  model: modelType;

  async getListByIds(ids: Array<string>) {
    const nids = ids.map(i => i && new ObjectId(i));
    const list = await this.model.find({ _id: nids }).populate('achieve').lean();
    return list;
  }
}
