import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { Admin } from '../../entity/user/admin.entity';
import { Role } from '../../entity/system/role.entity';
import { Menus } from '../../entity/system/menus.entity';

@Provide()
export class InitService {
  @InjectEntityModel(Admin)
  adminModel: ReturnModelType<typeof Admin>;
  @InjectEntityModel(Role)
  roleModel: ReturnModelType<typeof Role>;
  @InjectEntityModel(Menus)
  menusModel: ReturnModelType<typeof Menus>;

  async adminUser() {
    const num = await this.adminModel.count({ is_super: '1' });
    if (num > 0) return false;
    const data = {
      account: 'admin',
      password: '1qaz2wsx',
      nick_name: '系统管理员',
      is_super: '0',
    };
    const adminUser = await this.adminModel.create(data);
    return adminUser;
  }

  async initRole() {
    const datas = [
      { name: '管理员', code: 'admin' },
      { name: '个人用户', code: 'selfUser' },
      { name: '企业用户', code: 'unit' },
      { name: '科研单位', code: 'research' },
    ];
    await this.roleModel.insertMany(datas);
  }
  async initMenus() {
    const datas = [
      { name: '', order_num: 2, path: '', component: '', type: '' },
      { name: '', order_num: 2, path: '', component: '', type: '' },
      { name: '', order_num: 2, path: '', component: '', type: '' },
      { name: '', order_num: 2, path: '', component: '', type: '' },
      { name: '', order_num: 2, path: '', component: '', type: '' },
      { name: '', order_num: 2, path: '', component: '', type: '' },
    ];
  }
  async initRoleMenu(admin: Admin) {}

  async initDict(){

  }
}
