import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService, FrameworkErrorEnum, ServiceError } from 'free-midway-component';
import { Research } from '../../entity/user/research.entity';
import get = require('lodash/get');
import { Types } from 'mongoose';
const ObjectId = Types.ObjectId;
type modelType = ReturnModelType<typeof Research>;
@Provide()
export class ResearchService extends BaseService<modelType> {
  @InjectEntityModel(Research)
  model: modelType;
  async checkIsExist(data) {
    if (!get(data, 'account')) return true;
    const checkData: any = { account: get(data, 'account') };
    if (get(data, '_id')) checkData._id = { $ne: new ObjectId(get(data, '_id')) };
    const num = await this.model.count(checkData);
    if (num > 0) throw new ServiceError('账户已存在!', FrameworkErrorEnum.SERVICE_FAULT);
    return true;
  }
}
