import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { DictData } from '../entity/system/dictData.entity';
@Provide()
export class UtilService {
  @InjectEntityModel(DictData)
  model: ReturnModelType<typeof DictData>;
  async util() {
    const code = 'serviceArea';
    const list = [
      '北京',
      '天津',
      '河北省',
      '山西省',
      '内蒙古',
      '辽宁省',
      '吉林省',
      '黑龙江省',
      '上海',
      '江苏省',
      '浙江省',
      '安徽省',
      '福建省',
      '江西省',
      '山东省',
      '河南省',
      '湖北省',
      '湖南省',
      '广东省',
      '广西',
      '海南省',
      '重庆',
      '四川省',
      '贵州省',
      '云南省',
      '西藏',
      '陕西省',
      '甘肃省',
      '青海省',
      '宁夏',
      '新疆',
      '港澳台',
    ];
    const toInsertData = [];
    for (let i = 0; i < list.length; i++) {
      const data = { code, label: list[i], value: `${i}`, sort: i, is_use: '0' };
      toInsertData.push(data);
    }
    await  this.model.insertMany(toInsertData)
  }
  randomStr(len = 6) {
    return Math.random().toString(36).slice(-len);
  }
}
